library(FNN) #for the function knn.

stepArchetypoids <- function(i,nearest,data,ArchObj,sequ,aux){
  
  N = dim(data)[1]
  
  if(sequ){
   ai <- bestModel(ArchObj[[i]])
  }else{
   ai <- bestModel(ArchObj[[i-aux]])  
  }
  
  if(is.null(parameters(ai))){
    stop("No archetypes computed")  
  }else{
    ras <- rbind(parameters(ai),data)
    dras <- dist(ras, method = "euclidean", diag = F, upper = T, p = 2)
    mdras <- as.matrix(dras)
    diag(mdras) = 1e+11
   }
  func_nearest <- function(j,i){
    as.numeric(which.min(mdras[j,]) - (i))
  }
  
  if(nearest){
    ini_arch <- sapply(1:i, func_nearest, i)
    
    if( all(ini_arch > i) == FALSE){
      k=1
      neig <- knn(data, parameters(ai), 1:N, k=k)
      #neig <- get.knnx(data,parameters(ai),k=k)
      indices1 <- attr(neig, "nn.index")
      #indices1 <- neig$nn.index
      ini_arch <- indices1[,k]
      
      while(any(duplicated(ini_arch))){
        k=k+1  
        neig <- knn(data, parameters(ai), 1:N, k=k)
        #neig <- get.knnx(data,parameters(ai),k=k)
        indicesk <- attr(neig, "nn.index")
        #indicesk <- neig$nn.index
        
        dupl <- anyDuplicated(indices1[,1])
        ini_arch <- c(indices1[-dupl,1],indicesk[dupl,k])
        #indices1[dupl,1] <- indicesk[dupl,k]
        #ini_arch <- indices1
      }
    }
    
  }else{
    ini_arch <- apply(coef(ai, "alphas"), 2, which.max) 
  }
  
  res <- realArchetypes(data, huge = 200, i, ini_arch) #as.vector(ini_arch)
  cat("Done!") 
  return(list(res[[1]],res[[2]],ini_arch))
}