%Genetic algorithm in Matlab:
data = load('med1967.dat'); 
data = data(1:200,:);
sel = [48 40 39 33 34 36];
datapulg = data(:,sel) / (10 * 2.54);
siz = size(datapulg);
smpulg = zscore(datapulg);

Sx = cov(smpulg);
for I = 1 : siz(1)
     D2(I,:) = (smpulg(I,:) -  mean(smpulg)) * inv(Sx) * (smpulg(I,:) - mean(smpulg))'; 
end 
qlchi = find(D2 <= chi2inv(0.95,siz(2))); 
lsmpulg = smpulg(qlchi,:);

save lsmpulg.txt lsmpulg -ASCII

n = size(lsmpulg,1); 
m = size(lsmpulg,2);
p = 3;

x0 = load('xcRev.txt');
x0(x0 > 1) = 1;
xstat = [zeros(1,n*p) ones(1,n*p)]; 
xl = zeros(1,2*n*p);
xu = ones(1,2*n*p);
for i = 1 : n
    Aeq(i, ((i-1)*p + 1) : i*p) = 1;
end
for k = 1 : p
    Aeq(n + k, (n*(p + (k-1)) + 1) : n*(p+k)) = 1;
end    

Beq = ones(n + p,1);

A = [Aeq ; -Aeq];
b=[Beq;-Beq];
[x,fval,exitflag] = ga(@arquet,2*p*n,A,b,[],[],xl,xu,[],[n*p + 1 : 2*n*p]);

sum(x(1:n*p)) %For 200 individuals must sum up to 200.
sum(x((n*p+1):2*n*p)) %For 3 archetypoids must sum up to 3.
